﻿package com.shadeslider.project.views 
{
    import com.shadeslider.base.*;
    import com.shadeslider.project.consts.*;
    import com.shadeslider.project.events.*;
    import com.shadeslider.project.models.*;
    import com.shadeslider.utils.*;
    import flash.display.*;
    import flash.events.*;
    import flash.external.*;
    import flash.net.*;
    
    public class MainView extends com.shadeslider.base.CompositeView
    {
        public function MainView(arg1:flash.display.MovieClip, arg2:com.shadeslider.project.models.MainModel, arg3:Object)
        {
            super(arg1, arg2, arg3);
			this.setupModelListeners();
            this.addStageListeners();
            this.update();
            addEventListener(com.shadeslider.base.ViewEvent.INIT_DEFAULT_CHILDREN, this.onChildrenInitHandler);
            this.initDefaultAppearance();
            return;
        }

        protected override function addChildren():void
        {
            if (!config.bannerSmall)
            {
                addChild("toolbar", new com.shadeslider.project.views.ToolbarView(stageClip.toolbarView, model as com.shadeslider.project.models.MainModel, config));
            }
            addChild("scrollerHot", new com.shadeslider.project.views.ScrollerView(stageClip.scrollerViewHot, model as com.shadeslider.project.models.MainModel, config, {"itemType":com.shadeslider.project.consts.ItemType.ITEM_TYPE_HOT}));
            addChild("scrollerWarm", new com.shadeslider.project.views.ScrollerView(stageClip.scrollerViewWarm, model as com.shadeslider.project.models.MainModel, config, {"itemType":com.shadeslider.project.consts.ItemType.ITEM_TYPE_WARM}));
            addChild("scrollerCold", new com.shadeslider.project.views.ScrollerView(stageClip.scrollerViewCold, model as com.shadeslider.project.models.MainModel, config, {"itemType":com.shadeslider.project.consts.ItemType.ITEM_TYPE_COLD}));
            return;
        }

        private function onMainModelAppInitHandler():void
        {
            com.shadeslider.utils.VisualEffects.fadeIn(stageClip, 1000);
            return;
        }

        private function addStageListeners():void
        {
            var loc1:*;
            if (config.bannerSmall)
            {
                stageClip.expandWidget.addEventListener(flash.events.MouseEvent.CLICK, function (arg1:flash.events.MouseEvent):void
                {
                    ExternalInterface.call("window.showSG");
					//flash.external.ExternalInterface.call("eclipseWidgetExpand");
                    return;
                })
            }
            else 
            {
                stageClip.logoEclipseLink.addEventListener(flash.events.MouseEvent.CLICK, function (arg1:flash.events.MouseEvent):void
                {
                    flash.net.navigateToURL(new flash.net.URLRequest("http://eclipse.afisha.ru"), "_blank");
                    return;
                })
            }
            return;
        }

        private function setupModelListeners():void
        {
            return;
        }

        public override function initDefaultAppearance():void
        {
            stageClip.visible = false;
            stageClip.modalLayout.visible = false;
            if (config.bannerSmall)
            {
                stageClip.expandWidget.buttonMode = true;
                stageClip.expandWidget.useHandCursor = true;
            }
            else 
            {
                stageClip.logoEclipseLink.buttonMode = true;
                stageClip.logoEclipseLink.useHandCursor = true;
            }
            return;
        }

        protected override function modelState(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            var loc1:*=model.APP_STATE;
            switch (loc1) 
            {
                case com.shadeslider.project.events.ApplicationStates.APP_INIT:
                {
                    this.onMainModelAppInitHandler();
                    break;
                }
                case com.shadeslider.project.events.ApplicationStates.INIT_MODAL:
                {
                    stageClip.modalLayout.visible = true;
                    break;
                }
                case com.shadeslider.project.events.ApplicationStates.END_MODAL:
                {
                    stageClip.modalLayout.visible = false;
                    break;
                }
            }
            return;
        }

        protected override function update(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            return;
        }

        private function onChildrenInitHandler(arg1:com.shadeslider.base.ViewEvent):void
        {
            return;
        }
    }
}
